# -*-cperl-*-
# $Id: Geocoder.pm,v 1.1 2005/12/02 06:44:13 asc Exp $

use strict;

package ASCOPE::Article::Collection::Geocoder;

sub plot_locations {
        my $self = shift;
        my $args = shift;

        if (! $self->_geocoder({appid=>$args->{appid}})) {
                return undef;
        }

        my $stats = $self->stats();
        my %loc   = ();

        foreach my $place (keys %{$stats->{geo}}) {
                $loc{$place} = $self->plot_location($place);
        }

        return \%loc;
}

sub plot_location {
        my $self     = shift;
        my $location = shift;

        my $geo = $self->_geocoder();

        if (! $geo) {
                return undef;
        }

        my $res = $geo->geocode(location=>$location);

        if ((! $res) || (scalar(@$res) != 1)) {
                return undef;
        }

        return {
                name      => $location,
                country   => $res->[0]->{country},
                region    => $res->[0]->{state},
                locality  => $res->[0]->{city},
                latitude  => $res->[0]->{latitude}, 
                longitude => $res->[0]->{longitude},
               };
}

sub _geocoder {
        my $self = shift;
        my $args = shift;

        if ($self->{'__geo'}) {
                return $self->{'__geo'};
        }

        $args ||= {};

        if (! $args->{appid}) {
                return undef;
        }

        eval "require Geo::Coder::Yahoo";

        if ($@) {
                return undef;
        }

        my $geo = Geo::Coder::Yahoo->new(appid => $args->{appid});

        if (! $geo) {
                return undef;
        }

        $self->{'__geo'} = $geo;
        return $self->{'__geo'};
}

return 1;
